DeathClock = {};
DeathClock.countdown = 0;
DeathClock.gametime = 0;
DeathClock.Version = GetAddOnMetadata("DeathClock", "Version");
DeathClockDB = {};
DeathClockDB.TargetGUID = "";
DeathClockDB.DamageLog = {};
DeathClockDB.UnitNames = {
		["player"]="Player",
		["target"]="Target",
		["targettarget"]="Target's Target",
		["focus"]="Focus",
		["focustarget"]="Focus's Target",
		["mouseover"]="Mouseover",
		["mouseovertarget"]="Mouseover's Target",
		["pet"]="Pet",
		["pettarget"]="Pet's Target",
		["vehicle"]="Vehicle",
		["vehicletarget"]="Can Vehicles have Targets?"
	};
DeathClockSettings = {};

function DeathClock.OnLoad()
	DeathClock.LoadFrame();
	DeathClock.LoadPanel();

	UIParent:HookScript("OnUpdate", DeathClock.OnUpdate);
	
	SlashCmdList["DeathClock"] = DeathClock.SlashHandler;
	SLASH_DeathClock1 = "/DeathClock";
end

function DeathClock.OnEvent(_, event, arg1, arg2, _, _, _, _, _, arg8, _, _, _, arg12, arg13, _, arg15)
	-- event = Event Name
	-- arg1  = Timestamp or Addon Name
	-- arg2  = Damage Type
	-- arg8  = Target GUID
	-- arg12 = Damage Amount (SWING)
	-- arg13 = Damage Amount (ENVIRONMENTAL)
	-- arg15 = Damage Amount (all other types)
	
	if (event == "ADDON_LOADED" and arg1 == "DeathClock") then
		DeathClock.OnLoad();
	elseif (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		DeathClock.gametime = tonumber(arg1);
		if (arg2 == "SWING_DAMAGE") then
			DeathClock.Update(arg1, arg8, arg12);
		elseif (arg2 == "SPELL_DAMAGE") then
			DeathClock.Update(arg1, arg8, arg15);
		elseif (arg2 == "RANGE_DAMAGE") then
			DeathClock.Update(arg1, arg8, arg15);
		elseif (arg2 == "SPELL_PERIODIC_DAMAGE") then
			DeathClock.Update(arg1, arg8, arg15);
		elseif (arg2 == "SPELL_BUILDING_DAMAGE") then
			DeathClock.Update(arg1, arg8, arg15);
		elseif (arg2 == "DAMAGE_SHIELD") then
			DeathClock.Update(arg1, arg8, arg15);
		elseif (arg2 == "ENVIRONMENTAL_DAMAGE") then
			DeathClock.Update(arg1, arg8, arg15);
		else
			DeathClock.Update(arg1, 0, 0);
		end
	elseif (event == "PLAYER_ENTERING_WORLD") then
		DeathClock.LoadSettings();
	elseif (event == "PLAYER_TARGET_CHANGED") then
		DeathClock.Refresh();
	elseif (event == "UPDATE_MOUSEOVER_UNIT") then
		DeathClock.Refresh();
	end
end

function DeathClock.LoadPanel()
	local panel = CreateFrame("Frame", "DeathClockPanel", UIParent);
	panel.name = "DeathClock";
	panel.okay = function (self) DeathClock.Panel_Okay(); end;
	panel.default = function (self) DeathClock.Panel_Default(); end;
	
	-- Title
	local fonttitle = panel:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge");
	fonttitle:SetPoint("TOPLEFT", panel, "TOPLEFT", 15, -15);
	fonttitle:SetText("DeathClock  v"..DeathClock.Version);

	-- Combat Cache Limit
	local font = panel:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	font:SetPoint("TOPLEFT", fonttitle, "TOPLEFT", 0, -25);
	font:SetText("Combat Cache Time:");
	local dpx = CreateFrame("Slider", "DeathClockCache", panel, "OptionsSliderTemplate");
	dpx:SetPoint("TOPLEFT", font, "BOTTOMLEFT", 0, 0);
	dpx:SetWidth(380);
	dpx:SetOrientation("HORIZONTAL");
	dpx:SetMinMaxValues(5,30);
	dpx:SetValueStep(1);
	getglobal(dpx:GetName()..'Low'):SetText(5);
	getglobal(dpx:GetName()..'High'):SetText(30);
	dpx:SetScript("OnValueChanged", DeathClock.Panel_UpdateSlider);
	panel.dpx = dpx;
	
	-- Description
	local fontdesc = panel:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall");
	fontdesc:SetPoint("TOPLEFT", dpx, "BOTTOMLEFT", 0, -10);
	fontdesc:SetText("Set the time in seconds to average DPS from.");

	-- Timer stabilization
	local font = panel:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	font:SetPoint("TOPLEFT", fontdesc, "BOTTOMLEFT", 0, -20);
	font:SetText("Stabilization Factor:");
	local stb = CreateFrame("Slider", "DeathClockFactor", panel, "OptionsSliderTemplate");
	stb:SetPoint("TOPLEFT", font, "BOTTOMLEFT", 0, 0);
	stb:SetWidth(380);
	stb:SetOrientation("HORIZONTAL");
	stb:SetMinMaxValues(0,4);
	stb:SetValueStep(1);
	getglobal(stb:GetName()..'Low'):SetText(0);
	getglobal(stb:GetName()..'High'):SetText(4);
	stb:SetScript("OnValueChanged", DeathClock.Panel_UpdateSlider);
	panel.stb = stb;
	
	-- Description
	local fontdesc = panel:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall");
	fontdesc:SetPoint("TOPLEFT", stb, "BOTTOMLEFT", 0, -10);
	fontdesc:SetJustifyH("LEFT");
	fontdesc:SetText("Set the number of places to round the DPS to in order to\nkeep the countdown timer stable during fluctuation.\n\n0: 65521 DPS = 65521 DPS\n1: 65521 DPS = 65520 DPS\n2: 65521 DPS = 65500 DPS\n3: 65521 DPS = 66000 DPS\n4: 65521 DPS = 70000 DPS");
	
	-- UNIT TARGET
	local font = panel:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	font:SetPoint("TOPLEFT", fontdesc, "BOTTOMLEFT", 0, -20);
	font:SetText("Watch Unit:");
	local unitmenu = CreateFrame("Frame", "DeathClockUnit", panel, "UIDropDownMenuTemplate");
	unitmenu:SetPoint("TOPLEFT", font, "BOTTOMLEFT", 0, -10);
	UIDropDownMenu_SetWidth(DeathClockUnit, 200)
	panel.unitmenu = unitmenu;
	local fontdesc = panel:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall");
	fontdesc:SetPoint("TOPLEFT", unitmenu, "BOTTOMLEFT", 0, -10);
	fontdesc:SetJustifyH("LEFT");
	fontdesc:SetText("Select the unit you want DeathClock to watch.");
	
	-- Scripts
	panel:SetScript("OnShow", DeathClock.Panel_OnShow)
	panel.shown = false;
	
	InterfaceOptions_AddCategory(panel);
	DeathClock.panel = panel;
end

function DeathClock.Panel_UpdateSlider(self)
	_G[self:GetName().."Text"]:SetText(self:GetValue());
end

function DeathClock.Panel_OnShow()
	DeathClock.panel.dpx:SetValue(DeathClockSettings.cachetime);
	DeathClock.panel.stb:SetValue(DeathClockSettings.factor);
	UIDropDownMenu_Initialize(DeathClockUnit, DeathClock.Panel_InitialiseMenu);
	UIDropDownMenu_SetSelectedValue(DeathClockUnit, DeathClockSettings.unit, false);
	DeathClock.panel.shown = true;
end

function DeathClock.Panel_InitialiseMenu(self)
	local level = level or 1;
	local info = UIDropDownMenu_CreateInfo();
	for index,value in pairs(DeathClockDB.UnitNames) do
		info.text = value;
		info.value = index;
		info.owner = DeathClockUnit;
		info.checked = nil;
		info.icon = nil;
		info.func = DeathClock.Panel_ClickMenu;
		UIDropDownMenu_AddButton(info, level);
	end
end

function DeathClock.Panel_ClickMenu(self)
	UIDropDownMenu_SetSelectedValue(self.owner, self.value);
end

function DeathClock.Panel_Okay(self)
	if (DeathClock.panel.shown == true) then
		DeathClockSettings.cachetime = DeathClock.panel.dpx:GetValue();
		DeathClockSettings.factor = DeathClock.panel.stb:GetValue();
		DeathClockSettings.unit = UIDropDownMenu_GetSelectedValue(DeathClockUnit);
	end
end

function DeathClock.Panel_Default(self)
	DeathClockSettings = {};
	DeathClock.LoadSettings();
	DeathClock.Panel_OnShow();
end
	
function DeathClock.OnUpdate(self, elapsed)
	DeathClock.countdown = DeathClock.countdown - elapsed;
	if DeathClock.countdown < 0 then
		DeathClock.Refresh();
		DeathClock.countdown = 1;
	end
end

function DeathClock.SlashHandler(cmd)
	InterfaceOptionsFrame_OpenToCategory(DeathClock.panel);
end

function DeathClock.LoadSettings()
	DeathClockSettings.cachetime = DeathClockSettings.cachetime or 10;
	DeathClockSettings.factor = DeathClockSettings.factor or 1;
	DeathClockSettings.unit = DeathClockSettings.unit or "target";
	DeathClockSettings.point = DeathClockSettings.point or "TOP";
	DeathClockSettings.relativepoint = DeathClockSettings.relativepoint or "TOP";
	DeathClockSettings.posX = DeathClockSettings.posX or 0;
	DeathClockSettings.posY = DeathClockSettings.posY or -20;
	DeathClock.frame:SetPoint(DeathClockSettings.point, "UIParent", DeathClockSettings.relativepoint, DeathClockSettings.posX, DeathClockSettings.posY);
end

function DeathClock.SaveLoc()
	local point,_,relativepoint,posX,posY = DeathClock.frame:GetPoint(1);
	DeathClockSettings.point = point;
	DeathClockSettings.relativepoint = relativepoint;
	DeathClockSettings.posX = posX;
	DeathClockSettings.posY = posY;
end

function DeathClock.OnDragStop(self, button)
	self:StopMovingOrSizing();
	DeathClock.SaveLoc();
end

function DeathClock.OnDragStart(self, button)
	if (button == "LeftButton") then
		self:StartMoving();
	end
end

function DeathClock.OnMouseUp(self, button)
	if (button == "RightButton") then
		DeathClock.Bark();
	end
end

function DeathClock.LoadFrame()
	local frame = DeathClock.frame;

	frame:SetFrameStrata("HIGH");
	frame:SetWidth(100);
	frame:SetHeight(48);
	frame:SetMovable(true);
	frame:EnableMouse(true);
	frame:RegisterForDrag("LeftButton");
	frame:SetScript("OnMouseUp", DeathClock.OnMouseUp);
	frame:SetScript("OnDragStart", DeathClock.OnDragStart);
	frame:SetScript("OnDragStop", DeathClock.OnDragStop);
	frame:Hide()
	
	-- Background Texture
	local texture = frame:CreateTexture(nil, "BACKGROUND");
	texture:SetTexture(0, 0, 0, 0.8);
	texture:SetAllPoints(frame);
	
	-- Title Gradient
	local texture = frame:CreateTexture(nil, "ARTWORK");
	texture:SetTexture(1, 1, 1, 1);
	texture:SetGradient("VERTICAL", 0, 0, 0, 0, 0.7, 0);
	texture:SetPoint("TOPLEFT", frame);
	texture:SetWidth(100);
	texture:SetHeight(16);

	-- Title Text
	local title = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal");
	title:SetPoint("TOP", frame, "TOP", 0, 0);
	title:SetText("DeathClock");
	
	-- ETD Text
	local etd = frame:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	etd:SetPoint("TOPLEFT", frame, "TOPLEFT", 3, -16);
	frame.etd = etd;
	
	-- DPS Text
	local dps = frame:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
	dps:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -3, -32);
	frame.dps = dps;
	
	-- Save
	DeathClock.frame = frame;
end
	
function DeathClock.Update(timestamp, GUID, damage)
	local record = {timestamp, GUID, damage};
	tinsert(DeathClockDB.DamageLog, 1, record);
end

function DeathClock.Refresh()
	unitID = DeathClockSettings.unit;
	if UnitExists(unitID) then
		local dps, etd = DeathClock.GetDPS(unitID)
		if (dps > 0) then
			timeTilDeath = SecondsToTime(etd);
			if (timeTilDeath == "") then
				timeTilDeath = "0 Sec";
			end
			DeathClock.frame.etd:SetText(timeTilDeath);
			DeathClock.frame.dps:SetText(dps.." DPS");
			DeathClock.frame:Show();
		else
			DeathClock.frame:Hide();
		end
	else
		DeathClock.frame:Hide();
	end
end

-- [CALCULATE DPS FOR SPECIFIED TARGET]
function DeathClock.GetDPS(unitID)
	-- tableformat = {time, guid, damage}
	local lastRecord = {0, 0, 0};
	local totalDamage = 0;
	for recordIndex, damageRecord in ipairs(DeathClockDB.DamageLog) do
		if (DeathClock.gametime - damageRecord[1]) > DeathClockSettings.cachetime then
			-- Delete Expired Data
			tremove(DeathClockDB.DamageLog, recordIndex);
		elseif damageRecord[2] == UnitGUID(unitID) then
			lastRecord = damageRecord;
			totalDamage = totalDamage + damageRecord[3];
		end	
	end
	local dps = floor(totalDamage / DeathClockSettings.cachetime);
	local etd;
	if (dps > 0) then
		local fixdps = (floor((dps / 10^DeathClockSettings.factor) + 0.5) * 10^DeathClockSettings.factor);
		if (fixdps == 0) then
			fixdps = dps;
		end
		etd = UnitHealth(unitID) / fixdps;
	else
		etd = -1;
	end
	return dps, etd;
end

function DeathClock.GroupType()
	if(GetNumRaidMembers() > 0) then
		return "RAID";
	elseif (GetNumPartyMembers() > 0) then
		return "PARTY";
	end
	return "SAY";
end

function DeathClock.Bark()
	local unitID = DeathClockSettings.unit;
	local dps, etd = DeathClock.GetDPS(unitID);
	local timeTilDeath = DeathClock.SecondsToTime(etd);
	local msg = UnitName(unitID) .. ": "..timeTilDeath.." (Taking "..dps.." DPS)";
	DeathClock.Say(msg);
end

function DeathClock.SecondsToTime(seconds)
	local theTime = SecondsToTime(seconds);
	if (theTime == "") then
		theTime = "0 Sec";
	else
		for i=1,2 do
			local num = string.match(theTime, "(%d+) |4")
			if tonumber(num) ~= nil and tonumber(num) <= 1 then
				theTime = gsub(theTime, "|4(.-):.-;", "%1", 1)
			else
				theTime = gsub(theTime, "|4.-:(.-);", "%1", 1)
			end
		end
	end
	return theTime;
end

function DeathClock.Say(msg)
	--SendChatMessage
	SendChatMessage("[DeathClock] " .. msg, DeathClock.GroupType());
end

function DeathClock.Print(msg)
	if (DEFAULT_CHAT_FRAME) then
		msg = "|cFF00FF00[DeathClock]|r " .. msg;
		DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 1);
	end
end

DeathClock.frame = CreateFrame("Frame", nil, UIParent);
DeathClock.frame:RegisterEvent("ADDON_LOADED");
DeathClock.frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
DeathClock.frame:RegisterEvent("PLAYER_ENTERING_WORLD");
DeathClock.frame:RegisterEvent("PLAYER_TARGET_CHANGED");
DeathClock.frame:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
DeathClock.frame:SetScript("OnEvent", DeathClock.OnEvent);