

HideBlizz = LibStub("AceAddon-3.0"):NewAddon("HideBlizz", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("HideBlizz")
local db = nil
local cata_400 = select(4,GetBuildInfo()) >= 40000

raidHidden = nil
partyHidden = nil
playerHidden = nil

local options = {
	name = "HideBlizz",
	handler = HideBlizz,
	type = "group",
	args = {
		descrp = {
			   type = "description",
			   name = L["addon_desc"],
			   order = 0,
			  
			  },
		sep      = {
			   type = "header",
			   name = "",
			   order = 1,
			   },

		raidEnabled = {
				type = "toggle",
				name = L["HideRaid"],
				desc = L["HideRaidDesc"],
				get = function() return db.raidEnabled end,

				set = function(info, value) 
				local db = HideBlizz.db.profile				
				db.raidEnabled = value
				HideBlizz:UpdateFrames()
				end,
				order = 2,
				},
		playerEnabled = {
				type = "toggle",
				name = L["HidePlayer"],
				desc = L["HidePlayerDesc"],
				get = function() return db.playerEnabled end,

				set = function(info, value) 
				local db = HideBlizz.db.profile				
				db.playerEnabled = value
				HideBlizz:UpdateFrames()
				end,
				order = 3,
				},
		partyEnabled = {
				type = "toggle",
				name = L["HideParty"],
				desc = L["HidePartyDesc"],
				get = function() return db.partyEnabled end,

				set = function(info, value) 
				local db = HideBlizz.db.profile				
				db.partyEnabled = value
				HideBlizz:UpdateFrames()
				end,
				order = 4,
				},
		},
}

local defaults = {
	profile = {
		raidEnabled = true,
		partyEnabled = false,
		playerEnabled = false,
	},
}




		


function HideBlizz:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("HideBlizzDB", defaults, "Default")
	db = self.db.profile
    LibStub("AceConfig-3.0"):RegisterOptionsTable("HideBlizz", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HideBlizz", "HideBlizz")
    self:RegisterChatCommand("hideblizz", "ChatCommand")
    
	
    
end



function HideBlizz:UpdateFrames()
	
	 if self:IsEnabled() and db.raidEnabled then
		if not raidenabled then 
		    isRaidHidden = true
		    HideBlizz:hideraidframes()
			
		end
	 else
		if isRaidHidden then 
		  isRaidHidden = false		    
		  HideBlizz:showraidframes()

		end

	 end
	if  self:IsEnabled() and  db.partyEnabled then 
		if not partyEnabled then
		    ifPartyHidden = true
		  HideBlizz:hideParty()
		end
	else
		if not isParyHidden then
		   isPartyHidden = false
		   HideBlizz:showParty()
		end
	end

	if  self:IsEnabled() and  db.playerEnabled then 
		if not playerEnabled then
		   isPlayerHidden = true
		  HideBlizz:hidePlayer()
		end
	else
		if isPlayerHidden then 
		  isPlayerHidden = false
		 HideBlizz:showPlayer()
		end
	end
	
	

		 
	
end



function HideBlizz:OnEnable()
    self:UpdateFrames()

end

function HideBlizz:OnDisable()
    self:UpdateFrames()
end

function HideBlizz:OnProfileChanged(db, name)
	self:UpdateFrames()

	
end

-- Hiding code--
-- All credit goes to ckknight author of Pitbull
function HideBlizz:hideParty()
	for i = 1, 4 do
		local frame = _G["PartyMemberFrame"..i]
		frame:UnregisterAllEvents()
		frame:Hide()
		frame.Show = function() end
	end
	
	UIParent:UnregisterEvent("RAID_ROSTER_UPDATE")
end

function HideBlizz:showParty()
	for i = 1, 4 do
		local frame = _G["PartyMemberFrame"..i]
		frame.Show = nil
		frame:GetScript("OnLoad")(frame)
		frame:GetScript("OnEvent")(frame, "PARTY_MEMBERS_CHANGED")
		
		PartyMemberFrame_UpdateMember(frame)
	end
	
	UIParent:RegisterEvent("RAID_ROSTER_UPDATE")
end



function HideBlizz:showPlayer()
	PlayerFrame:GetScript("OnLoad")(PlayerFrame)
	PlayerFrame:Show()
	-- Emulate some events to get the frame setup in a normal state.
	-- Blizzard doesn't do an update on show for the player frame since
	-- they never imagine it won't be shown.
	PlayerFrame:GetScript("OnEvent")(PlayerFrame, "PLAYER_ENTERING_WORLD")
	PlayerFrame:GetScript("OnEvent")(PlayerFrame, "PARTY_MEMBERS_CHANGED")

	-- Hack to trick PlayerFrame into doing the swap for the vehicle if necessary.
	-- As a side benefit we end up doing the animation so it's kinda cool.
	PlayerFrame.animFinished = true
	PlayerFrame.inSeat = true
	PlayerFrame.inSequence = true
	PlayerFrame_UpdateArt(PlayerFrame)
end

function HideBlizz:hidePlayer()
	PlayerFrame:UnregisterAllEvents()
	PlayerFrameHealthBar:UnregisterAllEvents()
	PlayerFrameManaBar:UnregisterAllEvents()
	PlayerFrame:Hide()

end




function HideBlizz:showraidframes()
	if not cata_400 then return end
	CompactRaidFrameManager:GetScript("OnLoad")(CompactRaidFrameManager)
	if GetNumRaidMembers() > 0 then
		CompactRaidFrameManager:Show()
	end
	CompactRaidFrameContainer:RegisterEvent("RAID_ROSTER_UPDATE")
	CompactRaidFrameContainer:RegisterEvent("UNIT_PET")
	CompactRaidFrameContainer:Show()
end

function HideBlizz:hideraidframes()
	if not cata_400 then return end
	CompactRaidFrameManager:UnregisterAllEvents()
	CompactRaidFrameManager:Hide()
	CompactRaidFrameContainer:UnregisterEvent("RAID_ROSTER_UPDATE")
	CompactRaidFrameContainer:UnregisterEvent("UNIT_PET")
	CompactRaidFrameContainer:Hide()
end

function HideBlizz:ChatCommand(input)
   if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
   else
		LibStub("AceConfigCmd-3.0").HandleCommand(HideBlizz, "hideblizz", input)
   end
end