if select(6, GetAddOnInfo("PitBull4_" .. (debugstack():match("[o%.][d%.][u%.]les\\(.-)\\") or ""))) ~= "MISSING" then return end

local PitBull4 = _G.PitBull4
if not PitBull4 then
	error("PitBull4_SoulShardBar requires PitBull4")
end

if select(2, UnitClass("player")) ~= "WARLOCK" then
	return
end

local EXAMPLE_VALUE = 2/SHARD_BAR_NUM_SHARDS

local unpack = _G.unpack
local L = LibStub("AceLocale-3.0"):GetLocale("PitBull4_SoulShardBar")

local PitBull4_SoulShardBar = PitBull4:NewModule("SoulShardBar", "AceEvent-3.0")

PitBull4_SoulShardBar:SetModuleType("bar")
PitBull4_SoulShardBar:SetName(L["Soul Shard bar"])
PitBull4_SoulShardBar:SetDescription(L["Show a bar indicating the unit's Soul Shard count."])
PitBull4_SoulShardBar:SetDefaults({
	position = 3
})

function PitBull4_SoulShardBar:OnEnable()	
	self:RegisterEvent("UNIT_POWER")
	self:RegisterEvent("UNIT_DISPLAYPOWER")
end

local function update_player(self)
	for frame in PitBull4:IterateFramesForUnitID("player") do
		if frame.SoulShardBar then
			self:Update(frame)
		end
	end
end

function PitBull4_SoulShardBar:UNIT_POWER(event, unit, kind)
	if unit ~= "player" or kind ~= "SOUL_SHARDS" then
		return
	end
	
	update_player(self)
end

function PitBull4_SoulShardBar:UNIT_DISPLAYPOWER(event, unit)
	if unit ~= "player" then
		return
	end
	
	update_player(self)
end

local moduleUpdateFrame = PitBull4_SoulShardBar.UpdateFrame
function PitBull4_SoulShardBar:UpdateFrame(frame)
	if frame.unit ~= "player" then
		return self:ClearFrame(frame)
	end
	
	return moduleUpdateFrame(self, frame)
end

function PitBull4_SoulShardBar:GetValue(frame)
	return UnitPower("player", SPELL_POWER_SOUL_SHARDS) / SHARD_BAR_NUM_SHARDS
end

function PitBull4_SoulShardBar:GetExampleValue(frame)
	return EXAMPLE_VALUE
end

function PitBull4_SoulShardBar:GetColor(frame, value)
	return unpack(PitBull4.PowerColors.SOUL_SHARDS)
end

function PitBull4_SoulShardBar:GetExampleColor(frame, value)
	return unpack(PitBull4.PowerColors.SOUL_SHARDS)
end
